-- ====================================================================
--                  PROCEDIMENTO PARA ZERAR IMPLANTAO
--                  ------------ ---- ----- -----------
--
--  PARMETROS: P_FILIAL     = Cdigo da filial de lanamento.
--  ----------  P_NRLANCTO   = Nmero de um lanamento.
--              P_DTIMPLANT  = Data da implantao de estoque.
--              P_FILIMOVI   = Cdigo da filial a ser considerada.
--              P_CDALMOXARI = Cdigo do almoxarifado a ser considerado.
--              P_CDLOCAESTQ = Cdigo da localizao a ser considarada.
--
-- ====================================================================

-- @H:\Sistemas\Dba\Sql\Oracle\4004_ESTSTP_ZERA_IMPLANTACAO.SQL

CREATE OR REPLACE PROCEDURE ZERA_IMPLANTACAO(
				    P_FILIAL     IN ITLANCTOEST.CDFILIAL%TYPE    ,
 				    P_NRLANCTO   IN ITLANCTOEST.NRLANCESTQ%TYPE  ,
                P_DTIMPLANT  IN ITLANCTOEST.DTLANCMOVI%TYPE  ,
                P_FILIMOVI   IN ITLANCTOEST.CDFILIMOVI%TYPE  ,
                P_CDALMOXARI IN ITLANCTOEST.CDALMOXARIFE%TYPE,
                P_CDLOCAESTQ IN ITLANCTOEST.CDLOCALESTOQ%TYPE,
                P_SEQUITEM   IN OUT NUMBER)

AS

BEGIN

   DECLARE

      V_SEQUITEM  VARCHAR2(4);
      V_PRODUTO   VARCHAR2(10);
      V_DTPOSICAO DATE;

      CURSOR C_PRODZERA IS
         SELECT CDPRODUTO, MAX(DTPOSIESTQ) AS DTPOSIESTQ
         FROM POSESTDIA
         WHERE (CDFILIAL     = P_FILIMOVI)   AND
               (CDALMOXARIFE = P_CDALMOXARI) AND
               (CDLOCALESTOQ = P_CDLOCAESTQ) AND
               (DTPOSIESTQ   <= P_DTIMPLANT) AND
               (QTESTOQDIA   <> 0)           AND
                NOT (CDPRODUTO IN (SELECT CDPRODMOVI
                                   FROM ITLANCTOEST
                                   WHERE (CDFILIAL   = P_FILIAL) AND
                                         (NRLANCESTQ = P_NRLANCTO)))
         GROUP BY CDPRODUTO;

   BEGIN

      /* LER OS PRODUTOS QUE SERO ATUALIZADOS  */

      OPEN C_PRODZERA;
      LOOP
         FETCH C_PRODZERA INTO V_PRODUTO, V_DTPOSICAO;
         EXIT WHEN C_PRODZERA%NOTFOUND;

         P_SEQUITEM := P_SEQUITEM + 1;
         V_SEQUITEM := LPAD(RTRIM(TO_CHAR(P_SEQUITEM) + '0001'),4,0);

         INSERT INTO ITLANCTOEST (CDFILIAL , NRLANCESTQ, NRSEQUITEM, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO, QTTOTLANCTO, VRUNILANCTO, VRTOTLANCTO, DTLANCMOVI  , IDORDEMCLC, IDTIPOMOVI, CDPRODMOVI , QTLANCTOEST, VRLANCTOEST)
                          VALUES (P_FILIAL , P_NRLANCTO, V_SEQUITEM, P_FILIMOVI, P_CDALMOXARI, P_CDLOCAESTQ, V_PRODUTO, 0          , 0          , 0          , P_DTIMPLANT , '0'       , '0'       , V_PRODUTO  , 0          , 0          );

      END LOOP;
      CLOSE C_PRODZERA;
   END;
END;
/



