/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Planejamento Alimentar Industrial e Hospitalar                             */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: 0335_PLATRGS.sql                                                     */
/*                                                                            */
/* Descrio:                                                                 */
/* Ao excluir cardpio da tabela CARDADIA,  excludo tambm os efetivos      */
/* da tabela EFETCLIE(para o PLA) e EFETDIET(para o PAH)                      */
/*                                                                            */
/* Criao:                                                                   */
/* 11/01/2005 - Leonardo Leo de Assis                                        */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM SYSOBJECTS O, SYSUSERS U
          WHERE
             O.NAME = 'DELETE_EFETCLIE'  AND
             TYPE = 'TR'                 AND
             U.UID = O.UID               AND
             U.NAME = USER)
DROP TRIGGER DELETE_EFETCLIE
GO

CREATE TRIGGER DELETE_EFETCLIE
ON CARDADIA 
FOR DELETE
AS
DECLARE @V_COUNT INTEGER;
BEGIN
   SET @V_COUNT = 0;
   /* Sistema PLA */
   SELECT
      @V_COUNT = COUNT(*)
   FROM
      EFETCLIE E,
      DELETED D
   WHERE
      E.CDFILIAL   = D.CDFILIAL   AND
      E.CDSERVPLAN = D.CDSERVFILI AND
      E.DTEFETCLIE = D.DTCARDAPIO AND
      (E.CDFILIFATU IS NOT NULL AND E.NRAPURACFAT IS NOT NULL);
   IF (@V_COUNT > 0) BEGIN
      ROLLBACK TRANSACTION;
   END ELSE BEGIN
      DELETE FROM EFETCLIE
      WHERE 
         (CDFILIAL + CDSERVPLAN + CONVERT(VARCHAR, DTEFETCLIE, 103)) IN (SELECT
                                                                            CDFILIAL + CDSERVFILI + 
                                                                            CONVERT(VARCHAR, DTCARDAPIO, 103)
                                                                         FROM 
                                                                            DELETED);
   END;
   /* Sistema PAH */
   DELETE FROM EFETDIET
   WHERE
      (CDFILIAL + CDSERVFILI + CDDIETPAD + CONVERT(VARCHAR, DTEFETDIET, 103)) IN (SELECT
                                                                                     CDFILIAL + CDSERVFILI + CDDIETPAD + 
                                                                                     CONVERT(VARCHAR, DTCARDAPIO, 103)
                                                                                  FROM
                                                                                     DELETED);
END;
GO
