<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Entities\Base;


abstract class Resource {
    
    
    /** @var string  */
    protected $address;
    /** @var \Datetime  */
    protected $availableFrom;
    /** @var string  */
    protected $class;
    /** @var \Datetime  */
    protected $createdAt;
    /** @var int  */
    protected $createdBy;
    /** @var string  */
    protected $description;
    /** @var string  */
    protected $district;
    /** @var string  */
    protected $documentNumber;
    /** @var string  */
    protected $email;
    /** @var string  */
    protected $externalCode;
    /** @var int  */
    protected $externalId;
    /** @var int  */
    protected $id;
    /** @var string  */
    protected $isUser;
    /** @var string  */
    protected $name;
    /** @var string  */
    protected $nickName;
    /** @var int  */
    protected $organization;
    /** @var string  */
    protected $password;
    /** @var string  */
    protected $phone;
    /** @var float  */
    protected $rating = 1;
    /** @var string  */
    protected $resourcesType;
    /** @var string  */
    protected $status = 'A';
    /** @var \Datetime  */
    protected $updatedAt;
    /** @var int  */
    protected $updatedBy;
    /** @var string  */
    protected $zipCode;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\Calendar  */
    protected $calendar;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\City  */
    protected $city;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\Resource  */
    protected $parent;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\Permission[]  */
    protected $permissions = array (
);

    public function getAddress() {
        return $this->address;
    }
	public function setAddress($address = NULL) {
        $this->address = $address;
    }
	public function getAvailableFrom() {
        return $this->availableFrom;
    }
	public function setAvailableFrom(\Datetime $availableFrom = NULL) {
        $this->availableFrom = $availableFrom;
    }
	public function getClass() {
        return $this->class;
    }
	public function setClass($class = NULL) {
        $this->class = $class;
    }
	public function getCreatedAt() {
        return $this->createdAt;
    }
	public function setCreatedAt(\Datetime $createdAt) {
        $this->createdAt = $createdAt;
    }
	public function getCreatedBy() {
        return $this->createdBy;
    }
	public function setCreatedBy($createdBy = NULL) {
        $this->createdBy = $createdBy;
    }
	public function getDescription() {
        return $this->description;
    }
	public function setDescription($description = NULL) {
        $this->description = $description;
    }
	public function setExternalCode($externalCode = NULL) {
        $this->externalCode = $externalCode;
    }
	public function getExternalCode() {
         return $this->externalCode;
    }
	public function getDistrict() {
        return $this->district;
    }
	public function setDistrict($district = NULL) {
        $this->district = $district;
    }
	public function getDocumentNumber() {
        return $this->documentNumber;
    }
	public function setDocumentNumber($documentNumber = NULL) {
        $this->documentNumber = $documentNumber;
    }
	public function getEmail() {
        return $this->email;
    }
	public function setEmail($email = NULL) {
        $this->email = $email;
    }
	public function getExternalId() {
        return $this->externalId;
    }
	public function setExternalId($externalId = NULL) {
        $this->externalId = $externalId;
    }
	public function getId() {
        return $this->id;
    }
	public function setId($id) {
        $this->id = $id;
    }
	public function getIsUser() {
        return $this->isUser;
    }
	public function setIsUser($isUser = NULL) {
        $this->isUser = $isUser;
    }
	public function getName() {
        return $this->name;
    }
	public function setName($name = NULL) {
        $this->name = $name;
    }
	public function getNickName() {
        return $this->nickName;
    }
	public function setNickName($nickName = NULL) {
        $this->nickName = $nickName;
    }
	public function getOrganization() {
        return $this->organization;
    }
	public function setOrganization($organization) {
        $this->organization = $organization;
    }
	public function getPassword() {
        return $this->password;
    }
	public function setPassword($password = NULL) {
        $this->password = $password;
    }
	public function getPhone() {
        return $this->phone;
    }
	public function setPhone($phone = NULL) {
        $this->phone = $phone;
    }
	public function getRating() {
        return $this->rating;
    }
	public function setRating($rating) {
        $this->rating = $rating;
    }
	public function getResourcesType() {
        return $this->resourcesType;
    }
	public function setResourcesType($resourcesType) {
        $this->resourcesType = $resourcesType;
    }
	public function getStatus() {
        return $this->status;
    }
	public function setStatus($status = NULL) {
        $this->status = $status;
    }
	public function getUpdatedAt() {
        return $this->updatedAt;
    }
	public function setUpdatedAt(\Datetime $updatedAt) {
        $this->updatedAt = $updatedAt;
    }
	public function getUpdatedBy() {
        return $this->updatedBy;
    }
	public function setUpdatedBy($updatedBy = NULL) {
        $this->updatedBy = $updatedBy;
    }
	public function getZipCode() {
        return $this->zipCode;
    }
	public function setZipCode($zipCode = NULL) {
        $this->zipCode = $zipCode;
    }
	public function __construct() {
        $this->createdAt = new \DateTime();
		$this->updatedAt = new \DateTime();
    }
	public function getCalendar() {
        return $this->calendar;
    }
	public function setCalendar(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Calendar $calendar = NULL) {
        $this->calendar = $calendar;
    }
	public function getCity() {
        return $this->city;
    }
	public function setCity(\Zeedhi\DevOps\Model\Projectmanagement\Entities\City $city = NULL) {
        $this->city = $city;
    }
	public function getParent() {
        return $this->parent;
    }
	public function setParent(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Resource $parent = NULL) {
        $this->parent = $parent;
    }
	public function getPermissions() {
        return $this->permissions;
    }
	public function addPermission(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Permission $permission) {
        $this->permissions[] = $permission;
    }
}